/**
 * \file main.asm
 *
 * \brief RCUZpLqp̧
 *
 * Copyright (c) 2009-2015 Atmel Corporation. s
 *
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmel AVRiƂ̌qłĔzzĎgp邩
 *    B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 */


;*******************************************************************************
;* `
;*******************************************************************************
; ڼ޽蓖
.def	Zero			= R0
.def	One			= R1
.def	DetectCountL		= R2
.def	DetectCountH		= R3
.def	OVF_flag_clr		= R4
.def	temp			= R16
.def	temp1			= R17
.def	temp2			= R18
.def	temp3			= R19
.def	funcDataPass		= R20
.def	oscStepSize		= R21
.def	oscTrialValue		= R22
.def	default_OSCCAL		= R23
.def	calibPassesLeft		= R24

; ߰Ă݂̒`
.equ	PRGR_HANDSHAKE_PIN	= MISO
.equ	REF_FREQ_PIN		= MOSI
.equ	ISP_PIN_REG		= CAL_PIN
.equ	ISP_PORT_REG		= CAL_PORT
.equ	ISP_DDR_REG		= CAL_DDR

; Z萔̒`
.equ	CCYCLES		= 40		;ZԂƂĎgpC-ِ(͔񐄏Aӂđ)
.equ	TIMING_ERROR	= 2		;ތo͍ő2CPU̒xɂȂ蓾܂B
.equ	BEST_FIT	= ((((TARGET_FREQ*CCYCLES)*2) /CALIB_CLOCK_FREQ )+1)/2	;CCYCLESZłCPU(ۂ - ň̏ꍇ̊ۂߌ덷0.045%)
.equ	LIMIT		= (BEST_FIT*ACCURACY)/1000		;œKCPUɋőBtI덷UȂ悤ɐ؂l
.equ 	HIGH_LIMIT	=  BEST_FIT + LIMIT - TIMING_ERROR	;ň̏ꍇݸތ덷ɑ΂ďCCPU
.equ 	LOW_LIMIT	=  BEST_FIT - LIMIT + TIMING_ERROR	;ň̏ꍇݸތ덷ɑ΂ďCCPU

.equ	FREQ_WITHIN_LIM	= 0x00		;l = 0
.equ	TOO_FAST	= 0x01		;l = 1
.equ	TOO_SLOW	= 0xFF		;l =-1

; UłɈˑ萔
.ifndef OSC_VER
	.error " UŔԍ`Ă܂B"
.endif
.ifdef OSC_VER
	.if OSC_VER == 4
		.equ	INITIAL_STEP_SIZE	= 0x40	;OSCCAL͈͂7ޯ
		.equ	NUM_CALIB_PASSES	= 1	;ZKp
	.elif OSC_VER == 5
		.equ	INITIAL_STEP_SIZE	= 0X40	;OSCCAL͈͂7ޯā~2
		.equ	NUM_CALIB_PASSES	= 2	;ZKp
	.else
		.equ	INITIAL_STEP_SIZE	= 0x80	;OSCCAL͈͂8ޯ
		.equ	NUM_CALIB_PASSES	= 1	;ZKp
	.endif
.endif
;*******************************************************************************
;* ͸\
;*******************************************************************************
.CSEG
.org ADDR_START
	RJMP	Reset

;*******************************************************************************
;* 庰
;*******************************************************************************
.CSEG 
.org ADDR_MAIN

Reset:	CLR	Zero
	LDI	temp,0x01
	MOV	One,temp

Init_Stack:
; ޲SRAMgpꍇAAȂ΂܂B
.ifdef	SP
	.equ	SPL = SP
.endif
.ifdef SPL
	LDI	temp,low(RAMEND)
	OUT	SPL,temp
	.ifdef SPH
		LDI	temp,high(RAMEND)
		OUT	SPH,temp
	.endif
.endif

Init_interface:
; JTAG݂gpꍇJTAG̪͍ŏɋ֎~Ȃ΂Ȃ܂B
.ifdef JTAG_CALIB
	LDI	temp,1<<JTD
	OUT	MCUCSR,temp
	OUT	MCUCSR,temp
.endif

Init_IO:
	SETB	ISP_PORT_REG,REF_FREQ_PIN,temp		;ٱߋ
	SETB	ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;ٱߋ/Higho
	SETB	ISP_DDR_REG,PRGR_HANDSHAKE_PIN,temp	;޼o͕`Ԑݒ

CalibrationBegin:
	RCALL	newCalibrateRc

	LDI	temp,high(EEPROM_ADDRESS)
	OUT	EEARH,temp
	LDI	temp,low(EEPROM_ADDRESS)
	OUT	EEARL,temp

	LOAD	temp,OSCCAL
	OUT	EEDR,temp

	LDI	temp,1<<EEMWE
	OUT	EECR,temp
	LDI	temp,(1<<EEMWE) | (1<<EEWE)
	OUT	EECR,temp
	NOP

WaitForEepromReady:
	SBIC	EECR,EEWE
	RJMP	WaitForEepromReady

;------------------------------------------
; "ZOK" ޼
;------------------------------------------

.equ	HANDSHAKE_CYCLES	= 8


CalibSuccessful:
	LDI	temp1,HANDSHAKE_CYCLES	;Number of togglings in OK-handshake


	LDI	temp,(1<<PRGR_HANDSHAKE_PIN)		;ݐ؂ւ݂̂߂ɌŎg߂ɏ

CCS_WaitForPinHigh:
	IN	temp2,ISP_PIN_REG
	SBRS	temp2,REF_FREQ_PIN
	RJMP	CCS_WaitForPinHigh
;
	LOAD	temp3,ISP_PORT_REG
 	EOR	temp3,temp
CCS_WaitForPinLow:
	IN	temp2,ISP_PIN_REG
	SBRC	temp2,REF_FREQ_PIN
	RJMP	CCS_WaitForPinLow			;C-ۯɓ
;
	STORE	ISP_PORT_REG,temp3

Handshake_loop:
	DEC	temp1
	BRNE	CCS_WaitForPinHigh
;
	NOP

StopHere:
; JTAG݂gpꍇJTAG̪͍ĂэċȂ΂Ȃ܂B
.ifdef JTAG_CALIB
	LDI	temp,~(1<<JTD)
	OUT	MCUCSR,temp
	OUT	MCUCSR,temp
.endif

; ޲̎gɂ͉̌ނĂB
;	SBI_GEN		ISP_DDR_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" High쓮
;	SBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	SBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
;	CBI_GEN		ISP_PORT_REG,PRGR_HANDSHAKE_PIN,temp	;"MISO" Low쓮
EOP:
	RJMP	EOP	;ŌɁAISP݊킪޲ď݂܂łő҂܂B
 
;*******************************************************************************
;* Z֐:
;*
;* ŗǂLSCCALl邽߂2s܂B2̌ʂgx
;* łȂ΁Av邽߂4̍ŋOSCCCALlׂ܂B
;*
;*******************************************************************************
newCalibrateRc:
	CLR	oscTrialValue
	LDI	calibPassesLeft,NUM_CALIB_PASSES - 1

	INTERFACE_BUGFIX		;JTAGICE mkUۯ޸ނ̈ꎞIȏC

BinSearch:
	LDI	oscStepSize,INITIAL_STEP_SIZE	;OSCCAL͈͂MSBݒ(UłɈˑ128܂64)
	ADD	oscTrialValue,oscStepSize
BinSearchLoop:
	STORE	OSCCAL,oscTrialValue		;޲̈Ⴂ̂߂Ɏgp޲Lϸ
	NOP
	NOP
	RCALL	DetermineClockSpeed
	CPI	funcDataPass,FREQ_WITHIN_LIM	;gOKȂ΁A
	BREQ	FreqHit				;2I
;
	LSR	oscStepSize			;Ȃ΁Ap
	TST	oscStepSize

	BREQ	TryNeighbourghhoodValues	;oscStepSize0(Ȃ)ŗאڒlĎs
;
	MOV	temp,oscStepSize
	CPI	funcDataPass,TOO_FAST
	BRNE	AddStep
;
NegateNextStep:
	NEG	temp
AddStep:
	ADD	oscTrialValue,temp
	RJMP	BinSearchLoop

TryNeighbourghhoodValues:
; v邽߂ɍŋ3OSCCALl𒲍(xꂽ1͒܂B)
; 1i̗אڒl
	CPI	funcDataPass,TOO_FAST
	BREQ	DownstairsNeighbor
	LDI	oscStepSize,1
	RJMP	AddOscStep
DownstairsNeighbor:
	LDI	oscStepSize,-1
AddOscStep:
	ADD	oscTrialValue,oscStepSize
	STORE	OSCCAL,oscTrialValue		;޲̈Ⴂ̂߂Ɏgp޲Lϸ
	NOP
	NOP
	RCALL	DetermineClockSpeed
	CPI	funcDataPass,FREQ_WITHIN_LIM	;gOKȂA
	BREQ	FreqHit				;2I
; (O̒iKƓ)ŋ2i̗א
	ADD	oscTrialValue,oscStepSize
	STORE	OSCCAL,oscTrialValue		;޲̈Ⴂ̂߂Ɏgp޲Lϸ
	NOP
	NOP
	RCALL	DetermineClockSpeed
	CPI	funcDataPass,FREQ_WITHIN_LIM	;gOKȂA
	BREQ	FreqHit				;2I
; 2i̗א(t4iK)
	NEG	oscStepSize			;iKʂ𕉂(ɂĕ)
	LSL	oscStepSize			;2{
	LSL	oscStepSize			;2{ōv4{
	ADD	oscTrialValue,oscStepSize
	STORE	OSCCAL,oscTrialValue		;޲̈Ⴂ̂߂Ɏgp޲Lϸ
	NOP
	NOP
	RCALL	DetermineClockSpeed
	CPI	funcDataPass, FREQ_WITHIN_LIM	;gOKȂA
	BREQ	FreqHit				;2I

CalibPassCompleted:				;1̍Z񊮗AOSCCAL̏㔼łƎ񂪎sׂ𒲍
	TST 	calibPassesLeft
	BREQ	CalibrationFailure		;SZ񊮗OSCCALlȂȂAZ͎s
;
	DEC	calibPassesLeft
	LDI	oscTrialValue,0x80
	RJMP 	BinSearch

CalibrationFailure:
	SETB	ISP_DDR_REG,PRGR_HANDSHAKE_PIN,temp	;s}邽߂MISOLowɋ쓮
	RJMP	StopHere				;Zނ̍Ō֔

FreqHit:
	MOV	funcDataPass,oscTrialValue	;ŌOSCCALlōi
	RET

;*******************************************************************************
;* ۯ֐:
;*
;* 40ZۯԂ/0OVFgp܂B
;* funcDataPassŌ(TOO_FAST,TOO_SLOW)Ԃ܂B
;*******************************************************************************
DetermineClockSpeed:

Prepare_Detection:
	CLR	detectCountH
	LDI	temp,(1<<TOV0)
	MOV	OVF_flag_clr,temp
	LDI 	temp,(CCYCLES - 2)
	OUT	TCNT0,Zero
	LDI	temp1,(0<<CS02)|(0<<CS01)|(1<<CS00)	;x - ͼ ۯɈˑ܂B


WaitForPinHigh:
	SKBS	ISP_PIN_REG,REF_FREQ_PIN,temp3
	RJMP	WaitForPinHigh			;REF_FREQ_PINݐ؂ւJnOɂ͂܂B

WaitForPinLow:
	SKBC	ISP_PIN_REG,REF_FREQ_PIN,temp3
	RJMP	WaitForPinLow			;REF_FREQ_PINݐ؂ւJnOɂ͂܂B
	OUT	TCCR0,temp1

; ---- CC01 ----
DetectHighCC01:
	IN	temp2,TIFR
	SBRS	temp2,TOV0
	RJMP	DetectHighLoopCC01
;
	ADD	detectCountH,One
	OUT	TIFR,OVF_flag_clr
DetectHighLoopCC01:
	SKBS	ISP_PIN_REG,REF_FREQ_PIN,temp3
	RJMP	DetectHighLoopCC01

DetectLowCC01:
	IN	temp2,TIFR
	SBRS	temp2,TOV0
	RJMP	DetectLowLoopCC01
;
	ADD	detectCountH,One
	OUT	TIFR,OVF_flag_clr
DetectLowLoopCC01:
	SKBC	ISP_PIN_REG,REF_FREQ_PIN,temp3
	RJMP	DetectLowLoopCC01

; ---- JԂƂĎsCC02`CC39 ----
DetectHighCCxx:
	IN	temp2,TIFR
	SBRS	temp2,TOV0
	RJMP	DetectHighLoopCCxx
;
	ADD	detectCountH,One
	OUT	TIFR,OVF_flag_clr
DetectHighLoopCCxx:
	SKBS	ISP_PIN_REG,REF_FREQ_PIN,temp3
	RJMP	DetectHighLoopCCxx

DetectLowCCxx:
	IN	temp2,TIFR
	SBRS	temp2,TOV0
	RJMP	DetectLowLoopCCxx
;
	ADD	detectCountH,One
	OUT	TIFR,OVF_flag_clr
DetectLowLoopCCxx:
	SKBC	ISP_PIN_REG,REF_FREQ_PIN,temp3
	RJMP	DetectLowLoopCCxx

	DEC	temp
	BRNE	DetectHighCCxx

; ---- CC40 ----
DetectHighCC40:
	IN	temp2,TIFR
	SBRS	temp2,TOV0
	RJMP	DetectHighLoopCC40
;
	ADD	detectCountH,One
	OUT	TIFR,OVF_flag_clr
DetectHighLoopCC40:
	SKBS	ISP_PIN_REG,REF_FREQ_PIN,temp3
	RJMP	DetectHighLoopCC40

DetectLowCC40:
	IN	temp2,TIFR
	SBRS	temp2,TOV0
	RJMP	DetectLowLoopCC40
;
	ADD	detectCountH,One
	OUT	TIFR,OVF_flag_clr
DetectLowLoopCC40:
	SKBC	ISP_PIN_REG,REF_FREQ_PIN,temp3
	RJMP	DetectLowLoopCC40

Detect_End:
	OUT	TCCR0,Zero			;v~
CountLastOVF:
	IN	temp2,TIFR
	SBRS	temp2,TOV0
	RJMP	MergeTimerHighAndLow
;
	SEC
	ADC	detectCountH,Zero
	ANDI	temp2,(1<<TOV0)
	OUT	TIFR,temp2
MergeTimerHighAndLow:
	IN	detectCountL,TCNT0

CompareToLimits:
	LDI	temp1,low(HIGH_LIMIT)
	LDI	temp2,high(HIGH_LIMIT)
	CP	detectCountL,temp1
	CPC	detectCountH,temp2
	BRGE	TooFast				;detectHIGH_LIMITȂ番(v傫Ȃ̂ż ۯ)

	LDI	temp1,low(LOW_LIMIT)
	LDI	temp2,high(LOW_LIMIT)
	CP	temp1,detectCountL
	CPC	temp2,detectCountH
	BRGE	TooSlow				;detectLOW_LIMITȂ番(vȂ̂ż ۯx)
RightInTheEye:
	LDI	funcDataPass,FREQ_WITHIN_LIM
	RET
TooFast:
	LDI	funcDataPass,TOO_FAST
	RET
TooSlow:
	LDI	funcDataPass,TOO_SLOW		;TOO_SLOWޯĎՕł͂ȂlfuncDataPass=$00
	RET
